<template>
	<div class="ext-codexexample-lookup-demo">
		<label for="ext-codexexample-favorite-article">
			{{ $i18n( 'codexexample-app-lookup-label' ) }}
		</label>
		<cdx-lookup
			id="ext-codexexample-favorite-article"
			v-model:selected="selection"
			:menu-items="menuItems"
			:menu-config="menuConfig"
			clearable
			@input="onInput"
		>
			<template #no-results>
				{{ $i18n( 'codexexample-app-lookup-no-results' ) }}
			</template>
		</cdx-lookup>
		<p>{{ $i18n( 'codexexample-app-lookup-description' ) }}</p>

		<cdx-card
			v-if="selectedItem"
			class="ext-codexexample-lookup-demo__card"
			:thumbnail="selectedItem.thumbnail"
		>
			<template #title>
				{{ selectedItem.label }}
			</template>
			<template #description>
				{{ selectedItem.description }}
			</template>
		</cdx-card>
	</div>
</template>

<script>
const { ref, computed } = require( 'vue' );
const { CdxLookup, CdxCard } = require( '../../codex.js' );

/**
 * CdxLookup (and CdxCard) demo.
 */
// @vue/component
module.exports = {
	name: 'LookupDemo',
	components: {
		CdxLookup,
		CdxCard
	},
	setup() {
		// Lookup menu items.
		const menuItems = ref( [] );
		// Lookup menu config.
		const menuConfig = { showThumbnail: true };

		// Value of the selected item.
		const selection = ref( '' );
		// Data about the selected item that we'll display as a CdxCard.
		const selectedItem = computed( () =>
			menuItems.value.filter( ( item ) => item.value === selection.value )[ 0 ] || null );

		// Internal tracking ref for the current search term.
		const currentSearchTerm = ref( '' );

		/**
		 * Handle Lookup input.
		 *
		 * @param {string} value
		 */
		function onInput( value ) {
			// Internally track the current search term.
			currentSearchTerm.value = value;

			// Unset menu items if there is no value.
			if ( !value || value === '' ) {
				menuItems.value = [];
				return;
			}

			/**
			 * Format API results to be displayed as menu items.
			 *
			 * @param {Array} pages Pages returned by the API
			 * @return {Array} Menu item data
			 */
			function adaptApiResponse( pages ) {
				return pages.map( ( { id, title, description, thumbnail } ) => ( {
					label: title,
					value: id,
					description: description,
					thumbnail: thumbnail ? {
						url: thumbnail.url,
						width: thumbnail.width || undefined,
						height: thumbnail.height || undefined
					} : undefined
				} ) );
			}

			// This call is hardcoded for the sake of an easy example; don't do things this way.
			fetch(
				`https://en.wikipedia.org/w/rest.php/v1/search/title?q=${encodeURIComponent( value )}&limit=10&`
			).then( ( resp ) => resp.json() )
				.then( ( data ) => {
					// Make sure this data is still relevant first.
					if ( currentSearchTerm.value === value ) {
						// If there are results, format them into an array of menu item data to be
						// passed into Lookup for display.
						menuItems.value = data.pages && data.pages.length > 0 ?
							adaptApiResponse( data.pages ) :
							[];
					}
				} );
		}

		return {
			selection,
			menuItems,
			menuConfig,
			selectedItem,
			onInput
		};
	}
};
</script>

<style lang="less">
// To access Codex design tokens and mixins inside Vue files, import MediaWiki skin variables.
@import 'mediawiki.skin.variables.less';

.ext-codexexample-lookup-demo {
	&__card {
		margin-top: @spacing-100;
	}
}
</style>
